#!/usr/local/bin/python

import wx

from copy import copy
from math import *

def ChooseFileDialog(caption="Choose a file",folder="C:/",default="file.png",wildcard="*.png"):
    class SAPPWX(wx.Frame):
        myfile=""
        def __init__(self,parent,id,title):
            wx.Frame.__init__(self,parent,id,title)
            self.initialize()
        def initialize(self):
            dlg = wx.FileDialog(self, caption, folder, default, wildcard, wx.FD_SAVE)
            if dlg.ShowModal() == wx.ID_OK:
                SAPPWX.myfile = dlg.GetPath()
            self.Destroy()

    app = wx.PySimpleApp()
    frame = SAPPWX(None,-1,'Mi aplicacion')
    app.MainLoop()
    return SAPPWX.myfile




class vec:
    def __init__(self,v=[0.0,0.0]):
        if type(v) == list:
            self.data=v
        elif type(v) == tuple:
            self.data=list(v)
        elif v.__class__.__name__== self.__class__.__name__:
            self.data = copy(v.data)
        else:
            raise Exception("Wrong parameter type:" + str( type(v)) )

    def __repr__(self):
        s = "vec(" 
        for a in self.data: s += "%0.3f,"%a
        return s[:-1] + ")"

    def toList(self):
        return copy(v.data)

    # overload []
    def __getitem__(self, index):
        return self.data[index]

    # overload set []
    def __setitem__(self, key, item):
        self.data[key] = item

    def __add__(self, other):
        return vec( map(lambda a,b:a+b,self,other) ) #[self.data[0] + other.data[0],self.data[1] + other.data[1]] )

    def __sub__(self, other):
        return vec( map(lambda a,b:a-b,self,other) )

    def __mul__(self, other):
        if type(other) == int or type(other) == float:
            return vec( map(lambda a:a*other,self) )
        else:
            return vec( map(lambda a,b:a*b,self,other) )

    def __div__(self, other):
        if type(other) == int or type(other) == float:
            return vec( map(lambda a:a/float(other),self) )
        else:
            return vec( map(lambda a,b:a/float(b),self,other) )

    # return size to len()
    def __len__(self):
            return len(self.data)

    def copy(self,v):
        self.data = copy(v.data)
        
    def module(self):
        return sqrt(sum(map(lambda a: a*a,self.data) )  )

    def distance(self,b):
        return (b-self).module()

#*************************************

def cycle(a):
    a.insert(0,a.pop())

    
